## belr 0.1.3

=== CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2015  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

cmake_minimum_required(VERSION 3.0)
project(BELR VERSION 0.1.3 LANGUAGES C CXX)

set(BELR_SO_VERSION "1")

option(ENABLE_SHARED "Build shared library." ON)
option(ENABLE_STATIC "Build static library." ON)
option(ENABLE_STRICT "Build with strict compile options." YES)
option(ENABLE_TOOLS "Turn on or off compilation of tools." YES)


list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if(NOT CPACK_GENERATOR AND NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

include(GNUInstallDirs)
include(CheckSymbolExists)
include(CMakePushCheckState)

# find_package should be invoked here to check for libraries - however do NOT
# call include_directories here (see below)

if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
	set(BcToolbox_FIND_COMPONENTS tester)
	include("${EP_bctoolbox_CONFIG_DIR}/BcToolboxConfig.cmake")
else()
	find_package(BcToolbox 0.0.3 REQUIRED)
endif()

if(UNIX AND NOT APPLE)
	include(CheckIncludeFiles)
	check_include_files(libudev.h HAVE_LIBUDEV_H)
endif()

include_directories(
	include/
	src/
	${CMAKE_CURRENT_BINARY_DIR}
)
if(MSVC)
	include_directories(${MSVC_INCLUDE_DIR})
endif()

set(STRICT_OPTIONS_CPP )
set(STRICT_OPTIONS_C )
set(STRICT_OPTIONS_CXX )
set(STRICT_OPTIONS_OBJC )
if(MSVC)
	if(ENABLE_STRICT)
		list(APPEND STRICT_OPTIONS_CPP "/WX")
	endif()
else()
	list(APPEND STRICT_OPTIONS_CPP "-Wall" "-Wuninitialized" "-Wno-error=deprecated-declarations")
	list(APPEND STRICT_OPTIONS_C "-Wdeclaration-after-statement" "-Wstrict-prototypes" "-Wno-error=strict-prototypes")
	list(APPEND STRICT_OPTIONS_CXX "-std=c++11")
	if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
		list(APPEND STRICT_OPTIONS_CPP "-Qunused-arguments" "-Wno-array-bounds")
	endif()
	if(APPLE)
		list(APPEND STRICT_OPTIONS_CPP "-Wno-error=unknown-warning-option" "-Qunused-arguments" "-Wno-tautological-compare" "-Wno-unused-function" "-Wno-array-bounds")
		list(APPEND STRICT_OPTIONS_CXX "-stdlib=libc++")
	endif()
	if(ENABLE_STRICT)
		list(APPEND STRICT_OPTIONS_CPP "-Werror" "-Wextra" "-Wno-unused-parameter" "-fno-strict-aliasing")
	endif()
endif()
if(STRICT_OPTIONS_CPP)
	list(REMOVE_DUPLICATES STRICT_OPTIONS_CPP)
endif()
if(STRICT_OPTIONS_C)
	list(REMOVE_DUPLICATES STRICT_OPTIONS_C)
endif()

set(BELR_CPPFLAGS ${BCTOOLBOX_CPPFLAGS})
if(ENABLE_STATIC)
	list(APPEND BELR_CPPFLAGS "-DBELR_STATIC")
endif()
if(BELR_CPPFLAGS)
	list(REMOVE_DUPLICATES BELR_CPPFLAGS)
	add_definitions(${BELR_CPPFLAGS})
endif()
add_definitions("-DBELR_EXPORTS")

if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
	set(EXPORT_TARGETS_NAME "LinphoneBuilder")
else()
	set(EXPORT_TARGETS_NAME "belr")
endif()

add_subdirectory(include)
add_subdirectory(src)
if(ENABLE_TOOLS)
	add_subdirectory(tools)
endif()

include(CMakePackageConfigHelpers)
export(EXPORT ${EXPORT_TARGETS_NAME}Targets
	FILE "${CMAKE_CURRENT_BINARY_DIR}/BelrTargets.cmake"
)
configure_file(cmake/BelrConfig.cmake.in
	"${CMAKE_CURRENT_BINARY_DIR}/BelrConfig.cmake"
	@ONLY
)
set(ConfigPackageLocation share/Belr/cmake)
install(EXPORT ${EXPORT_TARGETS_NAME}Targets
	FILE BelrTargets.cmake
	DESTINATION ${ConfigPackageLocation}
)
install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/BelrConfig.cmake"
	DESTINATION ${ConfigPackageLocation}
)

add_subdirectory(build)

=== build/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2017  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

if (NOT CPACK_PACKAGE_NAME)
	set(CPACK_PACKAGE_NAME "belr")
ENDIF()

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../COPYING")

set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})

set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${PROJECT_VERSION})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES
"${CMAKE_BINARY_DIR}"
"^${PROJECT_SOURCE_DIR}/.git*"
)
bc_project_build_version(${PROJECT_VERSION} PROJECT_VERSION_BUILD)

set (CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_FILE_NAME}-${PROJECT_VERSION_BUILD}")

message("-- Package file name is ${CPACK_PACKAGE_FILE_NAME}" )

set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_FILE_NAME})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/rpm/belr.spec.in ${CMAKE_CURRENT_SOURCE_DIR}/../belr.spec)

include(CPack)

=== include/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2015  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(HEADER_FILES
	abnf.hh
	belr.hh
	grammarbuilder.hh
	parser.hh
	parser-impl.cc
)

set(BELR_HEADER_FILES )
foreach(HEADER_FILE ${HEADER_FILES})
	list(APPEND BELR_HEADER_FILES "${CMAKE_CURRENT_LIST_DIR}/belr/${HEADER_FILE}")
endforeach()
set(BELR_HEADER_FILES ${BELR_HEADER_FILES} PARENT_SCOPE)

install(FILES ${BELR_HEADER_FILES}
        DESTINATION include/belr
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2015  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(BELR_HEADER_FILES )
set(BELR_SOURCE_FILES_C )
set(BELR_SOURCE_FILES_CXX 
	abnf.cc
	belr.cc
	grammarbuilder.cc
	parser.cc
)

bc_apply_compile_flags(BELR_SOURCE_FILES_C STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(BELR_SOURCE_FILES_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

if(ENABLE_STATIC)
	add_library(belr-static STATIC ${BELR_HEADER_FILES} ${BELR_SOURCE_FILES_C} ${BELR_SOURCE_FILES_CXX})
	set_target_properties(belr-static PROPERTIES OUTPUT_NAME belr)
	target_include_directories(belr-static PUBLIC ${BCTOOLBOX_CORE_INCLUDE_DIRS})
	target_link_libraries(belr-static INTERFACE ${BCTOOLBOX_CORE_LIBRARIES})
endif()
if(ENABLE_SHARED)
	add_library(belr SHARED ${BELR_HEADER_FILES} ${BELR_SOURCE_FILES_C} ${BELR_SOURCE_FILES_CXX})
	if(APPLE)
		set_target_properties(belr PROPERTIES LINK_FLAGS "-stdlib=libc++")
	endif()
	set_target_properties(belr PROPERTIES VERSION ${BELR_SO_VERSION})
	target_include_directories(belr PUBLIC ${BCTOOLBOX_CORE_INCLUDE_DIRS})
	target_link_libraries(belr PRIVATE ${BCTOOLBOX_CORE_LIBRARIES})
	if(MSVC)
		if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
			install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_BUILD_TYPE}/belr.pdb
				DESTINATION ${CMAKE_INSTALL_BINDIR}
				PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
			)
		endif()
	endif()
endif()

if(ENABLE_STATIC)
	install(TARGETS belr-static EXPORT ${EXPORT_TARGETS_NAME}Targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()
if(ENABLE_SHARED)
	install(TARGETS belr EXPORT ${EXPORT_TARGETS_NAME}Targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

install(FILES ${BELR_HEADER_FILES}
	DESTINATION include/belr
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)

=== tools/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2015  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

if(ENABLE_SHARED)
	set(BELR_LIBRARIES_FOR_TOOLS belr)
else()
	set(BELR_LIBRARIES_FOR_TOOLS belr-static)
endif()

foreach(EXECTUABLE belr-parse belr-demo)
	set(SOURCE_FILES_CXX ${EXECTUABLE}.cc)
	bc_apply_compile_flags(SOURCE_FILES_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)
	add_executable(${EXECTUABLE} ${SOURCE_FILES_CXX})
	set_target_properties(${EXECTUABLE} PROPERTIES LINKER_LANGUAGE CXX)
	target_link_libraries(${EXECTUABLE} ${BELR_LIBRARIES_FOR_TOOLS} ${BCTOOLBOX_CORE_LIBRARIES})
	if(APPLE)
		set_target_properties(${EXECTUABLE} PROPERTIES LINK_FLAGS "-stdlib=libc++")
	endif()

endforeach()
if(NOT IOS)
	install(TARGETS belr-parse
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

=== debian/changelog ===
belr (0.1.3-2) unstable; urgency=medium

  * Use debhelper v11
  * Update d/copyright
  * Switch Vcs-URLs to salsa.d.o
  * Update Standards-Version to 4.1.3, no changes needed
  * Remove symbols file, it's too fragile for different architectures.
    (Closes: #881269)
  * Add shlibs file for libbelr1

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 16 Feb 2018 14:35:52 +0100

belr (0.1.3-1) unstable; urgency=medium

  * Initial release (Closes: #881195)

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 08 Nov 2017 20:27:12 +0100

=== debian/control ===
Source: belr
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
Build-Depends: debhelper (>= 11), cmake, libbctoolbox-dev
Standards-Version: 4.1.3
Section: libs
Homepage: https://www.linphone.org
Vcs-Git: https://salsa.debian.org/pkg-voip-team/belr.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/belr

Package: libbelr-dev
Section: libdevel
Architecture: any
Depends: libbelr1 (= ${binary:Version}), ${misc:Depends}
Description: language recognition library by Belledonne Communications (development headers)
 Belr is Belledonne Communications' language recognition library. It aims
 at parsing any input formatted according to a language defined by an
 ABNF grammar, such as the protocols standardized at IETF.
 .
 It is based on finite state machine theory and heavily relies on
 recursivity from an implementation standpoint.
 .
 The package is probably not useful outside the Belledonne Communications suite
 of libraries and programs.
 .
 This package contains the development headers.

Package: libbelr1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: language recognition library by Belledonne Communications
 Belr is Belledonne Communications' language recognition library. It aims
 at parsing any input formatted according to a language defined by an
 ABNF grammar, such as the protocols standardized at IETF.
 .
 It is based on finite state machine theory and heavily relies on
 recursivity from an implementation standpoint.
 .
 The package is probably not useful outside the Belledonne Communications suite
 of libraries and programs.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

# Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
# setting CMAKE_SKIP_RPATH
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%belr-$1.tar.gz%" \
   https://github.com/BelledonneCommunications/belr/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## belr 4.4.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # CMakeLists.txt
-# Copyright (C) 2015  Belledonne Communications, Grenoble France
+# Copyright (C) 2010-2019 Belledonne Communications, Grenoble France
 #
 ############################################################################
 #
@@ -20,8 +20,8 @@
 #
 ############################################################################
 
-cmake_minimum_required(VERSION 3.0)
-project(BELR VERSION 0.1.3 LANGUAGES C CXX)
+cmake_minimum_required(VERSION 3.1)
+project(BELR VERSION 4.4.0 LANGUAGES C CXX)
 
 set(BELR_SO_VERSION "1")
 
@@ -29,7 +29,8 @@
 option(ENABLE_STATIC "Build static library." ON)
 option(ENABLE_STRICT "Build with strict compile options." YES)
 option(ENABLE_TOOLS "Turn on or off compilation of tools." YES)
-
+option(ENABLE_TESTS "Enable compilation of unit tests." YES)
+option(ENABLE_PACKAGE_SOURCE "Create 'package_source' target for source archive making (CMake >= 3.11)" OFF)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -41,16 +42,17 @@
 include(GNUInstallDirs)
 include(CheckSymbolExists)
 include(CMakePushCheckState)
+include(CheckCXXCompilerFlag)
+
+if(MSVC)
+    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
+endif()
 
 # find_package should be invoked here to check for libraries - however do NOT
 # call include_directories here (see below)
+find_package(bctoolbox 0.0.5 REQUIRED OPTIONAL_COMPONENTS tester)
 
-if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
-	set(BcToolbox_FIND_COMPONENTS tester)
-	include("${EP_bctoolbox_CONFIG_DIR}/BcToolboxConfig.cmake")
-else()
-	find_package(BcToolbox 0.0.3 REQUIRED)
-endif()
+set(LINK_FLAGS )
 
 if(UNIX AND NOT APPLE)
 	include(CheckIncludeFiles)
@@ -58,8 +60,8 @@
 endif()
 
 include_directories(
-	include/
-	src/
+	include
+	src
 	${CMAKE_CURRENT_BINARY_DIR}
 )
 if(MSVC)
@@ -78,15 +80,18 @@
 	list(APPEND STRICT_OPTIONS_CPP "-Wall" "-Wuninitialized" "-Wno-error=deprecated-declarations")
 	list(APPEND STRICT_OPTIONS_C "-Wdeclaration-after-statement" "-Wstrict-prototypes" "-Wno-error=strict-prototypes")
 	list(APPEND STRICT_OPTIONS_CXX "-std=c++11")
-	if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+	if(CMAKE_C_COMPILER_ID MATCHES "Clang")
 		list(APPEND STRICT_OPTIONS_CPP "-Qunused-arguments" "-Wno-array-bounds")
 	endif()
 	if(APPLE)
 		list(APPEND STRICT_OPTIONS_CPP "-Wno-error=unknown-warning-option" "-Qunused-arguments" "-Wno-tautological-compare" "-Wno-unused-function" "-Wno-array-bounds")
-		list(APPEND STRICT_OPTIONS_CXX "-stdlib=libc++")
 	endif()
 	if(ENABLE_STRICT)
 		list(APPEND STRICT_OPTIONS_CPP "-Werror" "-Wextra" "-Wno-unused-parameter" "-fno-strict-aliasing")
+		CHECK_CXX_COMPILER_FLAG("-Wsuggest-override" SUGGEST_OVERRIDE)
+		if(SUGGEST_OVERRIDE)
+			list(APPEND STRICT_OPTIONS_CPP "-Wsuggest-override -Werror=suggest-override")
+		endif()
 	endif()
 endif()
 if(STRICT_OPTIONS_CPP)
@@ -106,34 +111,47 @@
 endif()
 add_definitions("-DBELR_EXPORTS")
 
-if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
-	set(EXPORT_TARGETS_NAME "LinphoneBuilder")
-else()
-	set(EXPORT_TARGETS_NAME "belr")
-endif()
+set(EXPORT_TARGET_NAME "belr")
+
+set(BELR_GRAMMARS_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/${EXPORT_TARGET_NAME}/grammars")
+set(BELR_GRAMMARS_RELATIVE_DIR "${CMAKE_INSTALL_DATADIR}/${EXPORT_TARGET_NAME}/grammars")
+
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 
 add_subdirectory(include)
 add_subdirectory(src)
+if(ENABLE_TESTS)
+  add_subdirectory(tester)
+endif()
 if(ENABLE_TOOLS)
 	add_subdirectory(tools)
 endif()
 
 include(CMakePackageConfigHelpers)
-export(EXPORT ${EXPORT_TARGETS_NAME}Targets
-	FILE "${CMAKE_CURRENT_BINARY_DIR}/BelrTargets.cmake"
+set(EXPORT_TARGET_NAME belr)
+set(ConfigPackageLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${EXPORT_TARGET_NAME}")
+
+export(EXPORT ${EXPORT_TARGET_NAME}Targets
+	FILE "${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Targets.cmake"
 )
-configure_file(cmake/BelrConfig.cmake.in
-	"${CMAKE_CURRENT_BINARY_DIR}/BelrConfig.cmake"
-	@ONLY
+
+configure_package_config_file(cmake/BelrConfig.cmake.in
+	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Config.cmake"
+	INSTALL_DESTINATION ${ConfigPackageLocation}
+	NO_SET_AND_CHECK_MACRO
 )
-set(ConfigPackageLocation share/Belr/cmake)
-install(EXPORT ${EXPORT_TARGETS_NAME}Targets
-	FILE BelrTargets.cmake
-	DESTINATION ${ConfigPackageLocation}
-)
-install(FILES
-	"${CMAKE_CURRENT_BINARY_DIR}/BelrConfig.cmake"
+
+install(EXPORT ${EXPORT_TARGET_NAME}Targets
+	FILE ${EXPORT_TARGET_NAME}Targets.cmake
 	DESTINATION ${ConfigPackageLocation}
 )
 
-add_subdirectory(build)
+#Yes, an install directive is necessary. The INSTALL_DESTINATION parameter of configure_package_config_file() above does NOTHING.
+install(FILES
+	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Config.cmake"
+	DESTINATION ${ConfigPackageLocation}
+)
+
+if (ENABLE_PACKAGE_SOURCE)
+	add_subdirectory(build)
+endif()

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2015  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(LIBS bctoolbox)

set(BELR_HEADER_FILES )
set(BELR_SOURCE_FILES_C )
set(BELR_SOURCE_FILES_CXX
	abnf.cpp
	belr.cpp
	grammarbuilder.cpp
	parser.cpp
	binarystream.cpp
)

bc_apply_compile_flags(BELR_SOURCE_FILES_C STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(BELR_SOURCE_FILES_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

add_definitions(
	-DBCTBX_LOG_DOMAIN="belr"
)

if(WIN32 AND NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
	list(APPEND LIBS ws2_32 Iphlpapi)
endif()

if(ENABLE_STATIC)
	add_library(belr STATIC ${BELR_HEADER_FILES} ${BELR_SOURCE_FILES_C} ${BELR_SOURCE_FILES_CXX})
	set_target_properties(belr PROPERTIES OUTPUT_NAME belr)
	target_link_libraries(belr PUBLIC ${LIBS})
	target_include_directories(belr INTERFACE
		$<INSTALL_INTERFACE:include>
		$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
	)
endif()
if(ENABLE_SHARED)
	add_library(belr SHARED ${BELR_HEADER_FILES} ${BELR_SOURCE_FILES_C} ${BELR_SOURCE_FILES_CXX})
	if(APPLE)
		if(IOS)
			set(MIN_OS ${LINPHONE_IOS_DEPLOYMENT_TARGET})
		else()
			set(MIN_OS ${CMAKE_OSX_DEPLOYMENT_TARGET})
		endif()
		set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/osx/")
		set_target_properties(belr PROPERTIES
			FRAMEWORK TRUE
			MACOSX_FRAMEWORK_IDENTIFIER org.linphone.belr
			MACOSX_FRAMEWORK_INFO_PLIST Info.plist.in
			PUBLIC_HEADER "${BELR_HEADER_FILES}"
		)
	endif()
	set_target_properties(belr PROPERTIES VERSION ${BELR_SO_VERSION})
	target_include_directories(belr INTERFACE
		$<INSTALL_INTERFACE:include>
		$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
	)
	target_link_libraries(belr PUBLIC ${LIBS})
	if(MSVC)
		if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
			install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_BUILD_TYPE}/belr.pdb
				DESTINATION ${CMAKE_INSTALL_BINDIR}
				PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
			)
		endif()
	endif()
endif()

install(TARGETS belr EXPORT ${EXPORT_TARGET_NAME}Targets
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	FRAMEWORK DESTINATION Frameworks
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install(FILES ${BELR_HEADER_FILES}
	DESTINATION include/belr
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)

=== tester/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2015  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

if(ENABLE_SHARED)
	set(BELR_LIBRARIES_FOR_TESTER belr)
else()
	set(BELR_LIBRARIES_FOR_TESTER belr)
endif()

set(GRAMMAR_FILES
	res/basicgrammar.txt
	res/vcardgrammar.txt
	res/sipgrammar.txt
	res/response.txt
	res/register.txt
)

set(BINARY_GRAMMAR_FILES res/belr-grammar-example.blr)

set(HEADER_FILES_CXX belr-tester.h)
set(SOURCE_FILES_CXX
	belr-tester.cpp
	grammar-tester.cpp
)

string(REPLACE ";" " " LINK_FLAGS_STR "${LINK_FLAGS}")

bc_apply_compile_flags(SOURCE_FILES_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

add_executable(belr_tester ${SOURCE_FILES_CXX} ${HEADER_FILES_CXX})
set_target_properties(belr_tester PROPERTIES LINKER_LANGUAGE CXX)
target_include_directories(belr_tester PUBLIC ${BCTOOLBOX_INCLUDE_DIRS})

target_link_libraries(belr_tester ${BELR_LIBRARIES_FOR_TESTER} bctoolbox bctoolbox-tester)

if(NOT "${LINK_FLAGS_STR}" STREQUAL "")
	set_target_properties(belle_sip_tester PROPERTIES LINK_FLAGS "${LINK_FLAGS_STR}")
endif()

if(NOT IOS)
	install(TARGETS belr_tester
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

install(FILES ${GRAMMAR_FILES} DESTINATION "${CMAKE_INSTALL_DATADIR}/belr-tester/res")
install(FILES ${BINARY_GRAMMAR_FILES} DESTINATION "${CMAKE_INSTALL_DATADIR}/belr/grammars")

=== debian/changelog ===
belr (4.4.13-2) unstable; urgency=medium

  * Team upload.
  * Release to unstable.
  * Drop Tobias Quathamer from Uploaders, add myself

 -- Bernhard Schmidt <berni@debian.org>  Fri, 25 Dec 2020 17:16:15 +0100

belr (4.4.13-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.4.13
  * Bump to debhelper-compat (= 12)
  * Change Vcs-* to linphone-stack subgroup

 -- Bernhard Schmidt <berni@debian.org>  Mon, 07 Dec 2020 11:36:11 +0100

belr (4.4.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.4.0
  * Bump build-dep on linphone-sdk 4.4
  * Run wrap-and-sort

 -- Bernhard Schmidt <berni@debian.org>  Tue, 01 Sep 2020 00:43:44 +0200

belr (4.3.1-1) experimental; urgency=medium

  * Team upload.
  * d/watch: Switch to upstream primary Gitlab, only use releases
  * New upstream version 4.3.1
  * Disable Tests (need bcunit) and static building

 -- Bernhard Schmidt <berni@debian.org>  Tue, 02 Jun 2020 00:09:55 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: belr
 Priority: optional
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
-Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
-Build-Depends: debhelper (>= 11), cmake, libbctoolbox-dev
+Uploaders: Bernhard Schmidt <berni@debian.org>
+Build-Depends: cmake,
+               debhelper-compat (= 12),
+               libbctoolbox-dev (>= 4.4.0~)
 Standards-Version: 4.1.3
 Section: libs
 Homepage: https://www.linphone.org
-Vcs-Git: https://salsa.debian.org/pkg-voip-team/belr.git
-Vcs-Browser: https://salsa.debian.org/pkg-voip-team/belr
+Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/belr.git
+Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/belr
 
 Package: libbelr-dev
 Section: libdevel
@@ -28,7 +30,7 @@
 
 Package: libbelr1
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: language recognition library by Belledonne Communications
  Belr is Belledonne Communications' language recognition library. It aims
  at parsing any input formatted according to a language defined by an

=== debian/rules ===
--- 
+++ 
@@ -19,4 +19,4 @@
 # Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
 # setting CMAKE_SKIP_RPATH
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON
+	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DENABLE_STATIC=no -DENABLE_TESTS=no

## belr 5.0.37

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # CMakeLists.txt
-# Copyright (C) 2010-2019 Belledonne Communications, Grenoble France
+# Copyright (C) 2010-2021 Belledonne Communications, Grenoble France
 #
 ############################################################################
 #
@@ -20,8 +20,12 @@
 #
 ############################################################################
 
-cmake_minimum_required(VERSION 3.1)
-project(BELR VERSION 4.4.0 LANGUAGES C CXX)
+
+# CMake 3.13 required for new Flexisip build process.
+# See [CMP077](https://cmake.org/cmake/help/v3.13/policy/CMP0077.html).
+cmake_minimum_required(VERSION 3.13)
+
+project(BELR VERSION 5.0.0 LANGUAGES C CXX)
 
 set(BELR_SO_VERSION "1")
 
@@ -31,6 +35,10 @@
 option(ENABLE_TOOLS "Turn on or off compilation of tools." YES)
 option(ENABLE_TESTS "Enable compilation of unit tests." YES)
 option(ENABLE_PACKAGE_SOURCE "Create 'package_source' target for source archive making (CMake >= 3.11)" OFF)
+
+# Hidden non-cache options:
+# * DISABLE_BC_PACKAGE_SEARCH: skip find_package() for every BC package (bctoolbox, ortp, etc.)
+
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -50,7 +58,9 @@
 
 # find_package should be invoked here to check for libraries - however do NOT
 # call include_directories here (see below)
-find_package(bctoolbox 0.0.5 REQUIRED OPTIONAL_COMPONENTS tester)
+if(NOT DISABLE_BC_PACKAGE_SEARCH)
+	find_package(bctoolbox 0.0.5 REQUIRED OPTIONAL_COMPONENTS tester)
+endif()
 
 set(LINK_FLAGS )
 
@@ -131,9 +141,11 @@
 set(EXPORT_TARGET_NAME belr)
 set(ConfigPackageLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${EXPORT_TARGET_NAME}")
 
-export(EXPORT ${EXPORT_TARGET_NAME}Targets
-	FILE "${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Targets.cmake"
-)
+if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
+	export(EXPORT ${EXPORT_TARGET_NAME}Targets
+		FILE "${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Targets.cmake"
+	)
+endif()
 
 configure_package_config_file(cmake/BelrConfig.cmake.in
 	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Config.cmake"

=== debian/changelog ===
belr (5.0.37-2) unstable; urgency=medium

  * Team upload.
  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Mon, 12 Sep 2022 08:24:53 +0200

belr (5.0.37-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 5.0.37

 -- Dennis Filder <d.filder@web.de>  Wed, 08 Jun 2022 23:20:48 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Bernhard Schmidt <berni@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
-               libbctoolbox-dev (>= 4.4.0~)
-Standards-Version: 4.1.3
+               debhelper-compat (= 13),
+               libbctoolbox-dev (>= 5.0.37~)
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
 Section: libs
 Homepage: https://www.linphone.org
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/belr.git
@@ -14,6 +15,7 @@
 Package: libbelr-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libbelr1 (= ${binary:Version}), ${misc:Depends}
 Description: language recognition library by Belledonne Communications (development headers)
  Belr is Belledonne Communications' language recognition library. It aims
@@ -30,6 +32,7 @@
 
 Package: libbelr1
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: language recognition library by Belledonne Communications
  Belr is Belledonne Communications' language recognition library. It aims

## belr 5.1.64

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,11 +21,15 @@
 ############################################################################
 
 
-# CMake 3.13 required for new Flexisip build process.
-# See [CMP077](https://cmake.org/cmake/help/v3.13/policy/CMP0077.html).
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.1)
 
-project(BELR VERSION 5.0.0 LANGUAGES C CXX)
+# CMP0077 policy is required by Flexisip build. Remove it once the CMake required
+# version is higer or equal to 3.13.
+if(NOT CMAKE_VERSION VERSION_LESS 3.13)
+    cmake_policy(SET CMP0077 NEW)
+endif()
+
+project(BELR VERSION 5.1.0 LANGUAGES C CXX)
 
 set(BELR_SO_VERSION "1")

=== tester/CMakeLists.txt ===
--- 
+++ 
@@ -40,6 +40,7 @@
 set(SOURCE_FILES_CXX
 	belr-tester.cpp
 	grammar-tester.cpp
+	parser.cpp
 )
 
 string(REPLACE ";" " " LINK_FLAGS_STR "${LINK_FLAGS}")

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -23,22 +23,19 @@
 if(ENABLE_SHARED)
 	set(BELR_LIBRARIES_FOR_TOOLS belr)
 else()
-	set(BELR_LIBRARIES_FOR_TOOLS belr-static)
+	set(BELR_LIBRARIES_FOR_TOOLS belr)
 endif()
 
-foreach(EXECTUABLE belr-parse belr-demo)
-	set(SOURCE_FILES_CXX ${EXECTUABLE}.cc)
+foreach(EXECUTABLE belr-parse belr-demo belr-compiler)
+	set(SOURCE_FILES_CXX ${EXECUTABLE}.cc)
 	bc_apply_compile_flags(SOURCE_FILES_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)
-	add_executable(${EXECTUABLE} ${SOURCE_FILES_CXX})
-	set_target_properties(${EXECTUABLE} PROPERTIES LINKER_LANGUAGE CXX)
-	target_link_libraries(${EXECTUABLE} ${BELR_LIBRARIES_FOR_TOOLS} ${BCTOOLBOX_CORE_LIBRARIES})
-	if(APPLE)
-		set_target_properties(${EXECTUABLE} PROPERTIES LINK_FLAGS "-stdlib=libc++")
-	endif()
+	add_executable(${EXECUTABLE} ${SOURCE_FILES_CXX})
+	set_target_properties(${EXECUTABLE} PROPERTIES LINKER_LANGUAGE CXX)
+	target_link_libraries(${EXECUTABLE} ${BELR_LIBRARIES_FOR_TOOLS} bctoolbox)
+endforeach()
 
-endforeach()
 if(NOT IOS)
-	install(TARGETS belr-parse
+	install(TARGETS belr-parse belr-compiler
 		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
 		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
 		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}

=== debian/changelog ===
belr (5.1.64-2) unstable; urgency=medium

  * Upload to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Sun, 27 Nov 2022 17:26:13 +0100

belr (5.1.64-1) experimental; urgency=medium

  * New upstream release.

 -- Dennis Filder <d.filder@web.de>  Wed, 05 Oct 2022 19:23:09 +0200

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,14 @@
 Uploaders: Bernhard Schmidt <berni@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               libbctoolbox-dev (>= 5.0.37~)
-Standards-Version: 4.6.0
+               libbctoolbox-dev (>= 5.1.64~)
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://www.linphone.org
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/belr.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/belr
+Description: Parser generator library for ABNF grammars
 
 Package: libbelr-dev
 Section: libdevel

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/belr.*\.tar\.gz/belr-$1\.tar\.gz/g \
  https://gitlab.linphone.org/BC/public/belr/tags?sort=updated_desc .*/archive/([\d\.]+)/.*\.tar\.gz.*

## belr 5.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
     cmake_policy(SET CMP0077 NEW)
 endif()
 
-project(BELR VERSION 5.1.0 LANGUAGES C CXX)
+project(BELR VERSION 5.2.0 LANGUAGES C CXX)
 
 set(BELR_SO_VERSION "1")

=== build/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2010-2019  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

cmake_minimum_required(VERSION 3.11) # we need CMake 3.11 for defining 'package_source' target as custom target

if(NOT CPACK_PACKAGE_NAME)
	set(CPACK_PACKAGE_NAME "belr")
endif()

set(CPACK_SOURCE_IGNORE_FILES
	"${CMAKE_BINARY_DIR}"
	"^${PROJECT_SOURCE_DIR}/.git*"
)

bc_make_package_source_target()

=== include/CMakeLists.txt ===
--- 
+++ 
@@ -21,11 +21,10 @@
 ############################################################################
 
 set(HEADER_FILES
-	abnf.hh
-	belr.hh
-	grammarbuilder.hh
-	parser.hh
-	parser-impl.cc
+	abnf.h
+	belr.h
+	grammarbuilder.h
+	parser.h
 )
 
 set(BELR_HEADER_FILES )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,7 @@
 		else()
 			set(MIN_OS ${CMAKE_OSX_DEPLOYMENT_TARGET})
 		endif()
-		set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/osx/")
+		set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/build/osx/")
 		set_target_properties(belr PROPERTIES
 			FRAMEWORK TRUE
 			MACOSX_FRAMEWORK_IDENTIFIER org.linphone.belr
@@ -76,7 +76,7 @@
 	target_link_libraries(belr PUBLIC ${LIBS})
 	if(MSVC)
 		if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
-			install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_BUILD_TYPE}/belr.pdb
+			install(FILES $<TARGET_PDB_FILE:belr>
 				DESTINATION ${CMAKE_INSTALL_BINDIR}
 				PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
 			)

=== debian/changelog ===
belr (5.2.0-2build3) noble; urgency=medium

  * No-change rebuild against libbctoolbox1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 09 Apr 2024 02:09:18 +0000

belr (5.2.0-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:43:02 +0000

belr (5.2.0-2build1) noble; urgency=medium

  * No-change rebuild against libbctoolbox1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 03:00:28 +0000

belr (5.2.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Fri, 28 Jul 2023 22:35:16 +0200

belr (5.2.0-1) experimental; urgency=medium

  * New upstream release 5.2.0.
  * Comply with Debian policy v4.6.2.

 -- Dennis Filder <d.filder@web.de>  Mon, 19 Dec 2022 18:48:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: belr
 Priority: optional
-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Bernhard Schmidt <berni@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               libbctoolbox-dev (>= 5.1.64~)
-Standards-Version: 4.6.1
+               libbctoolbox-dev (>= 5.2.0~)
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://www.linphone.org

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # See debhelper(7) (uncomment to enable)
 # output every command that modifies files on the build system.
 #export DH_VERBOSE = 1
+include /usr/share/dpkg/pkg-info.mk
 
 
 # see FEATURE AREAS in dpkg-buildflags(1)
@@ -19,4 +20,8 @@
 # Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
 # setting CMAKE_SKIP_RPATH
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DENABLE_STATIC=no -DENABLE_TESTS=no
+	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON \
+		-DENABLE_STATIC=no \
+		-DENABLE_TESTS=no \
+		-DDEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM) \
+		-DENABLE_TOOLS=no
